#!/usr/bin/perl

my $it = 10;	# number of iterations (the higher, the better the stats)

my $ng = 0;	# number of generations (default 0 => reach the BEST genome)
my $pm = 0.08;  # mutation probability
my $pc = 0.9;   # crossover probability
my $mg = 5000; # max number of generations (stop even if optimum is not found)
my $ps = 25;    # popsize

my $score;
my $score_tot;
my $score_avg;

my $gener;
my $gener_tot;
my $gener_avg;

my $time;
my $time_tot;
my $time_avg;

my $string;

for ($pc = 0.1; $pc<=0.9 ; $pc+=.1){
	
	$score_tot = 0;
	$gener_tot = 0;
	$time_tot  = 0;

	printf "Running GA %02d times with the following params: ps=%02d ng=%04d mg=%04d pm=%.2f pc=%.2f\n", 
		$it, $ps, $ng, $mg, $pm, $pc;
	for ($ii=1;$ii<=$it;$ii++){
		$result = `./prova ps $ps ng $ng mg $mg pm $pm pc $pc`;
		if ($result =~ /objective score is (.*?)\)/){
			$score = $1;
		}
		if ($result =~ /Generations: (\d+)/){
			$gener = $1;	
		}
		if ($result =~ /Total time: (\d+)/){
			$time = $1;
		}
		if ($result =~ /:\n(.*?)\nTotal time/s){
			$string = $1;
		}
		
		$score_tot += $score;
		$gener_tot += $gener;
		$time_tot  += $time;
		
		printf "Test %02d: ",$ii;
		printf "Score = %.04f ",$score;
		printf "Gen = %05d ", $gener;
		printf "Time = %03d ", $time;
		print "String = $string\n";
	}
	$score_avg = $score_tot / $it;
	$gener_avg = $gener_tot / $it;
	$time_avg = $time_tot / $it;
	
	printf "Average: Score = %.04f Gen = %05d Time = %03d\n", $score_avg, $gener_avg, $time_avg;
}

