/* ---------------------------------------------------------------------------- 
   NSCEKAI 
   Netscape Cache Explorer Genetic Keygen 
---------------------------------------------------------------------------- */ 
      
#include <stdio.h>
#include <string.h>
#include <ga/GASimpleGA.h>	 // we're going to use the simple GA
#include <ga/GA1DBinStrGenome.h> // and the 1D binary string genome

float Objective(GAGenome &); // This is the declaration of our obj function.
			     // The definition comes later in the file.
char *genome2string (GAGenome &);

char *alpha = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_";
char *name = "whatever";
char p[9], r[9], s[9];

int main (int argc,char **argv){
// See if we've been given a seed to use (for testing purposes).  When you
// specify a random seed, the evolution will be exactly the same each time
// you use that seed number.
  for(int ii=1; ii<argc; ii++) {
    if(strcmp(argv[ii++],"seed") == 0) {
      GARandomSeed((unsigned int)atoi(argv[ii]));
    }
  }
  
  int width    = 48; // that is, 6 bits x 8 chars
  int popsize  = 20;
  int ngen     = 10;
  float pmut   = 0.01;
  float pcross = 0.9;

  int gennum = 0;
  float objective;

  // create genome objects
  GA1DBinaryStringGenome genome(width, Objective);
  GA1DBinaryStringGenome bestgenome(width, Objective);
  
  // create and setup ga
  GASimpleGA ga(genome);
  ga.populationSize(popsize);
  ga.nGenerations(ngen);
  ga.pMutation(pmut);
  ga.pCrossover(pcross);
  ga.initialize();
  
  do {
  	// evolve for ngen generations
	for (int i=0;i<ngen;i++) ++ga;
	
	// print out the best genome found.
	printf ("The GA found this password for name \"%s\":\n",name);
	cout << ga.statistics().bestIndividual() << "\n";
	
	gennum += ngen;
	bestgenome = ga.statistics().bestIndividual();
	printf ("%s\n", genome2string(bestgenome));
	objective = Objective(bestgenome);

	printf ("Generation: %04d Score: %.0f\n\n",gennum,objective);
	for (int i=0;i<=width;i++) printf ("-");
	printf ("\n");
  } while (objective<400);

  // print stats for the last generation
  for (int i=0;i<ga.population().size();i++){
	cout << ga.population().individual(i) << " (" << Objective(ga.population().individual(i)) << ")\n";
  }

  return 0;
	
}

// genome2string converts a genome into the matching string
char *genome2string (GAGenome& g){
	GA1DBinaryStringGenome & genome = (GA1DBinaryStringGenome &)g;
	int substr = 6;
	int l = 0;
	int strptr = 0;
	for(int i=0;i<int(sizeof(s));i++) s[i]=0;
	for(int i=0; i<genome.length(); i++){
		substr--;
		l += (genome.gene(i)*(1<<substr));
		if (substr==0){
			s[strptr] = alpha[l];
			substr=6; l=0; strptr++;
		}
	}
	return s;
}


// This is the objective function: look at NSCE keycheck algo!
float Objective(GAGenome& g) {
	GA1DBinaryStringGenome & genome = (GA1DBinaryStringGenome &)g;
  	int i;
	genome2string (genome);
	
  	for (i=0;i<8;i++){
		p[i]=(s[i]-((name[i]%26)+65));
		if (p[i]<0) p[i]+= 26;
		r[i]=(p[i]+i)%10;
	}
	int j=0;
	for (i=0;i<7;i++){
		j += (r[i]*r[i+1]);
	}
	return float(abs(400-abs(400-j)));
}

